# CostaPy
# Copyright (C) 2022 Dita Aji Pratama
#
# This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with this program. If not, see https://www.gnu.org/licenses/.

from    bottle                  import Bottle, route, request, response
import  json

from    config                  import directory

import  templates.plain.main	as template_public
import  templates.postcard.main	as template_email

import  modules.public.home     as public_home
import  modules.public.register as public_register

import  modules.api.auth        as api_auth

app = Bottle()

@app.route('/')
def index():
    params = {
        "mako":{
            "website" : template_public.main(directory.page["public"], "home")
        }
    }
    return public_home.home().html(params)

@app.route('/register/<roles>')
def index(roles):
    params = {
        "roles" :roles,
        "mako"  :{
            "website" : template_public.main(directory.page["public"], "register")
        }
    }
    return public_register.register().html(params)


@app.route('/api/auth/registration/register/<roles>', method='POST')
def index(roles):
    try:
        params = request.json
        params["roles"  ] = roles
        params["mako"   ] = {
            "email" : template_email.main(directory.page["email"], "verification")
        }
        response.content_type = 'application/json'
        return json.dumps(api_auth.auth().register(params), indent = 2).encode()
    except Exception as e:
        print(str(e))
        return json.dumps({}, indent = 2).encode()
